////////////////////////////////////////////////////////////////
// Copyright G. Allaire, Juillet 2001
//
// Sur divers schemas de differences finies
// pour l'equation de la chaleur:
// mise en evidence d'instabilite, convergence
// trois schemas: centre instable, explicite, implicite
//
////////////////////////////////////////////////////////////////
//
// equation de la chaleur
// u,t - u,xx = 0
//
////////////////////////////////////////////////////////////////
//
lg = 10. ; // lg = demi-longueur du domaine
dx = 0.1 ; // dx = pas d'espace
nx = 2*lg/dx+1 ; // nx = nombre de noeuds

//
// initialisation
//

x=linspace(-lg,lg,nx) ;

u0=bosse(x);

ymax=max(u0);
ymin=min(u0);

u=u0 ;
up=u0 ;
um=u0 ;
uexacte=u0 ;

tics=[4,10,4,10];
rect=[-lg,ymin-0.1,lg,ymax+0.1];

xdel();
xbasc();
plotframe(rect,tics,'donnee initiale');
plot2d(x,u0,1,"000")


halt() ;
////////////////////////////////////////////////////////////////
// schema explicite: cfl=0.4
////////////////////////////////////////////////////////////////
//
cfl = 0.4    ;     // cfl
dt = dx*dx*cfl ; // dt = pas de temps.
Tfinal=1;      // Temps final souhait.
nt = int(Tfinal/dt);  // nt = nombre de pas de temps effectues.

Tfinal=nt*dt;    // Temps final.

titre=msprintf('schema explicite, cfl=%.2f',cfl);

for n=1:nt
//
up = shift('+1',u) ;
um = shift('-1',u) ;

u=u + dt/(dx*dx)*(up+um-2*u) ;

if modulo(n,5) == 0
        xbasc()
        plotframe(rect,tics,titre);
        plot2d(x,u,[1,1],"100","schema explicite")
        plot2d(x,u0,[2,2],"100","donnee initiale")
  end
//
end

// comparaison au temps final
        uexacte = zeros(1,nx) ;
      
        for i=1:nx
	for j=1:nx
              uexacte(i) = uexacte(i) + u0(j)*dx*noyau((i-j)*dx,Tfinal) ;
        end
	end

        xbasc()
        plotframe(rect,tics,titre);
        plot2d(x,u,[1,1],"100","schema explicite")
	plot2d(x,u0,[2,2],"100","donnee initiale")
        plot2d(x,uexacte,[3,3],"100","solution exacte")
       

